/*  KRunning - EventEdit.cpp
 *  Copyright (C) 2002 by Andreas Scherf
 *  Begin Mon Jul 8 2002 write to scherfa@web.de if you found a bug.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "EventEdit.h"
#include "EventView.h"

using namespace std;

EventEdit::EventEdit (QWidget * parent, const char *name) : AddEventDialog(parent,name,true) {
    UnitCombo->clear();
    UnitCombo->insertItem(i18n("km"),-1);
    UnitCombo->insertItem(i18n("m"),-1);
    UnitCombo->insertItem(i18n("miles"),-1);
    BlockGroupBox->setEnabled(false);
    connect ((QObject*)DistanceEdit,SIGNAL(returnPressed()),this, SLOT(distanceReturnPressed()) );
    //    connect ((QObject*)StartNumberCheck,SIGNAL(toggled(bool)),this, SLOT(startNumberCheckToggled(bool)) );
    // connect ((QObject*)NewEventButton, SIGNAL( clicked() ),this, SLOT( newEventClicked() ) );
    connect ((QObject*)AddBlockButton,SIGNAL(clicked()),this,SLOT(addBlockClicked()));
    connect((QPushButton *)buttonOk, SIGNAL(clicked()), SLOT(slotOk()));
    connect((QCheckBox *)cbAddBlock, SIGNAL(clicked()),SLOT(cbAddBlockClicked()));
    //connect (ListView1, SIGNAL( selectionChanged( QListViewItem* ) ),  this, SLOT( eventSelected( QListViewItem* )));

    //connect(ListView1,SIGNAL(itemRenamed (QListViewItem *,const QString &,int)),this,SLOT(slotEventChanged(QListViewItem *,const QString &,int)));
    m_pParent=parent;
    QToolTip::add(DistanceEdit,i18n("Enter the distance of the course\nand press enter to save the new event."));
    m_pEventObject=0;
    //buttonOk->setEnabled(false);
}

EventEdit::~EventEdit() {
	if (m_pEventObject)
	{
		delete m_pEventObject;
		m_pEventObject=0;
	}
}
/*
void EventEdit::slotEventChanged(QListViewItem *item,const QString &name,int col) {
    QString frameblock;
    QStringList events;
    // DBConnection::eventObj -> save (true) means update ...
    //eventObj event=dbconn->getEventByName(item->text(0));

    if (item->text(0).contains(i18n("Distance"),true)>0) {
        eventObject->setDistance(name.toInt());
    } else if (item->text(0).contains(i18n("Starttime"),true)>0) {
        eventObject->setStartTime(QTime::fromString(name));
    }

    events=dbconn->getEventNameList();
    if (! events.grep(item->text(0)).isEmpty()) {
        eventObject->setEventName(name);
    }

    eventObject->save(true);
    cerr <<  item->text(0) << "-" << item->text(1) <<"-" << name <<  endl;

}
*/
/*
QListViewItem * EventEdit::findListItem(const QString &name) {
    QListViewItem *data = new QListViewItem (mainItem);
    return data;
}
*/
void EventEdit::setDefaultSettings() {
    BlockGroupBox->setEnabled(false);
    setEnableEditFields(false);
    // initListView();
}

void EventEdit::distanceReturnPressed() {

    if (!EventNameEdit->text().isEmpty() && TimeEdit->time().isValid() && !DistanceEdit->text().isEmpty())
    {
        buttonOk->setEnabled(true);
    }
    //eventObj *event=new eventObj(0,EventNameEdit->text(),"",TimeEdit->time() ,DistanceEdit->text().toInt());
    //event->save();       // Tree update und nummer muss eindeutig sein
    //newItem->replaceEvent(event);
    //ListView1->clear();
    // initListView();
    //setEnableEditFields(false);
    // in der View muss nun die Event Liste angepasst werden

}
bool EventEdit::checkInputWidgets()
{
	bool bReturn = false;
    if (!EventNameEdit->text().isEmpty() && TimeEdit->time().isValid() && !DistanceEdit->text().isEmpty())
    {
        bReturn=true;
    }
	return bReturn;
}
/*

void EventEdit::newEventClicked() {
    eventObj *event=new eventObj(-1,i18n("new Event") ,"",QTime::currentTime(),0);
    newItem= new EventListItem (mainItem,event);
    newItem->setSelected(TRUE);
    eventSelected((QListViewItem *)newItem);
    ListView1->sort();
    ListView1->triggerUpdate();
    setEnableEditFields(true);
    EventNameEdit->setFocus();
    EventNameEdit->selectAll();
}
*/
void EventEdit::addBlockClicked() {
    //if (ListView1->selectedItem()==0) return;
    QString frame = QString("%1-%2").arg(FromNumInput->value()).arg(ToNumInput->value());
    if (dbconn->testStartNumberFrame(frame) != -1) return;  // Check if this frame exists or a number from this frame ...
    // eventObj event=dbconn->getEventByName( ListView1->selectedItem()->text(0));
    // event.addStartNumberFrame(frame);
    // event.save(true); // Update event
    //initListView();  // Only Item update !!

}

void EventEdit::cbAddBlockClicked()
{
    bool bEnable=cbAddBlock->isChecked();
    if (bEnable && !EventNameEdit->text().isEmpty())
    {
        BlockGroupBox->setEnabled(bEnable);
    }
}

void EventEdit::show()
{
	AddEventDialog::show();
	if (m_pEventObject)
	{
		EventNameEdit->setText(m_pEventObject->getEventName());
		TimeEdit->setTime(m_pEventObject->getEventStarttime());
		
		DistanceEdit->setText(QString("%1").arg(m_pEventObject->getEventDistance()));
		//UnitCombo->setCurrentItem(m_pEventObject->getDistanceString());
		// TODO Select correct entrys here ...
		buttonOk->setEnabled(true);
	}
}




void EventEdit::setEnableEditFields(bool state) {
    EventNameEdit->setEnabled(state);
    TimeEdit->setEnabled(state);
    DistanceEdit->setEnabled(state);
    UnitCombo->setEnabled(state);
}

void EventEdit::slotOk() {
    
	if (checkInputWidgets())
    {
		if (m_pEventObject)
		{
			m_pEventObject->setEventName(EventNameEdit->text());
			m_pEventObject->setDistance(DistanceEdit->text().toInt());
			m_pEventObject->setStartTime(TimeEdit->time());
			m_pEventObject->save(true);
		}
		else
		{
			m_pEventObject=new eventObj(0,EventNameEdit->text() ,"",TimeEdit->time() ,DistanceEdit->text().toInt());
			m_pEventObject->save();
		}
        	

        
        delete m_pEventObject;
		m_pEventObject=0;
    }
    ((EventView *)m_pParent)->initListView();
}

